# meds/bots/cli.py
#
#

""" console programma voor de enkele gebruiker. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.defines import GREEN, ENDC
from meds.main import fleet
from meds.object import Object
from meds.bots import Bot
from meds.cfg import cfg

import time
import sys

## CLI

class CLI(Bot):

    """ bot running on the console. """

    cc = "none"
    default = ""

    def raw(self, *args, **kwargs): sys.stdout.write(str(args[0])) ; sys.stdout.write("\n")

    def say(self, *args, **kwargs): self.raw(args[1])

    def prompt(self, *args, **kwargs):
        self.wait()
        if cfg.main.colors: return "%s %s<%s " % (time.ctime(time.time()).split()[-2], GREEN, ENDC)
        else: return "%s < " % (time.ctime(time.time()).split()[-2])

    def event(self, *args, **kwargs):
        event = Object()
        event._target = self
        event.origin = "root@shell"
        self.ready()
        event.txt = input(self.prompt())
        return event

    def start(self, *args, **kwargs):
        fleet.append(self)
        if not cfg.main.shell:
            thrs = self.single(" ".join(cfg.main.runargs))
            if thrs: self.collect(thrs)
            self.ready()
            return
        Bot.start(self, *args, **kwargs)
 