# desk.py
#
#

""" show version. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.main import main, plugins
from meds.utils.time import elapsed
from meds.utils.name import naming
from meds.object import Object
from meds.cfg import cfg

import threading
import logging
import types
import time
import os

from meds import __version__

import logging

## DEFINES

txt = "Omstandigheden die verplichten tot mishandeling gepleegd door toediening van voor het leven of de gezondheid schadelijke stoffen. #ggz"

license_txt = """ Copyright 2015, B.H.J. Thate

MEDS - Omstandigheden die verplichten tot mishandeling gepleegd door toediening van voor het leven of de gezondheid schadelijke stoffen. #ggz

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

* As the creator of this piece of software, Bart Thate,
  i disclaim all rights on the code contained in this software package.

* Therefore this software is free of all claims on it.

* This program is a given, therefore no one can be able to put it
  under any restriction, limitations or bounds.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.""" 

## CMNDS

def status_uptime(event):
    from meds.main import main
    event.reply("uptime is %s" % elapsed(time.time() - main._start))

main.register("status.uptime", status_uptime)

def desk_copyright(event): event.reply(__copyright__)

main.register('desk.copyright', desk_copyright)

def desk_version(event): event.reply("MEDS #%s - %s" % (__version__, txt.strip()))

main.register("desk.version", desk_version)

def desk_test(event): event.reply("hello %s" % event.origin)

main.register("desk.test", desk_test)

def desk_cmnds(event):
    if not event.parsed.rest:
       result = set([x.split(".")[-1] for x in main.names()])
       event.reply(", ".join(sorted(result)))
       return
    name = ""
    keys = main.search(event.parsed.rest)
    if keys: event.reply(", ".join(keys))

main.register("desk.cmnds", desk_cmnds)

def desk_ls(event):
    if not event.parsed.args: event.reply(", ".join(main.prefixes(*event.parsed.args)))
    else:
        for path in main.ls(*event.parsed.args): event.reply(path)

main.register("desk.ls", desk_ls)

def desk_prefix(event): event.reply(", ".join(main.prefixes(*event.parsed.args)))

main.register("desk.prefix", desk_prefix)

def desk_local(event):
    if not event.parsed.rest:
       result = set([x.split(".")[-1] for x in main.names() if '.' not in x])
       if result: event.reply(", ".join(sorted(result)))
       return
    name = ""
    keys = main.search(event.parsed.rest)
    if keys: event.reply(", ".join(keys))

main.register("desk.local", desk_local)

def desk_plugins(event):
    rest = event.parsed.rest
    if not rest:
       result = set(plugins.names())
       event.reply(", ".join(sorted([".".join(x.split(".")[1:]) for x in result])))
       return
    name = ""
    keys = plugins.search(rest)
    event.reply(", ".join([".".join(x.split(".")[1:]) for x in keys]))

main.register("desk.plugins", desk_plugins)

def desk_cfg(event):
    bot = event._target
    if bot.type != "CLI":
        botcfg = main.last("cfg", bot.type.lower())
        if not botcfg or "owner" not in botcfg or event.origin != botcfg.owner: event.reply("EOWNER %s" % event.origin) ; return
    obj = cfg
    if event.parsed.args:
        ctype = event.parsed.args[0]
        obj = main.last("cfg", ctype)
        if not obj: obj = cfg.get(ctype, None)
    try: 
        key = event.parsed.args[1]
        value = event.parsed.args[2]
        if key in obj:
            if type(obj[key]) in [list, tuple]: obj[key].append(value)
            else: obj[key] = value
            obj.prefix = "cfg"
            obj.sync()
    except IndexError: pass
    if obj: event.reply("\n".join(obj.show()))

main.register("desk.cfg", desk_cfg)

def desk_main(event): event.reply(main.pretty())

main.register("desk.main", desk_main)

def desk_where(event):
    name = event.parsed.rest
    cmnds = main.search(name)
    result = []
    for name in cmnds: result.extend([x.plugname for x in main.get(name)])
    if result: event.reply(", ".join(set(result)))

main.register("desk.where", desk_where)

def desk_ps(event):
    results = []
    for thr in threading.enumerate():
        if str(thr).startswith("<_"): continue
        obj = Object() 
        obj.update(vars(thr))
        txt = naming(thr)
        try: obj = obj.__class__.__self__
        except: pass
        if "_error" in obj: txt += " %s" % obj._error
        if "_status" in obj: txt += " %s" % obj._status
        if "_start" in obj: txt += " %s" % elapsed(int(time.time()) - int(obj._start))
        if "sleep" in obj and "_last" in obj: txt += " next %s/%s" % (elapsed(int(obj.sleep) - int(time.time() - int(obj._last))), elapsed(int(obj.sleep)))
        results.append(txt)
    nr = 0
    for result in sorted(results):
        nr += 1
        event.reply("%s %s" % (nr, result))
    return nr

main.register("desk.ps", desk_ps)

def desk_usage(event):
    data = os.popen("ps -p %s -o pid,tid,class,rtprio,ni,pri,psr,rss,pcpu,stat,wchan:14,comm" % os.getpid()).read().strip()
    event.reply(str(data))

main.register("desk.usage", desk_usage)

def desk_license(event): event.reply(license_txt)

main.register("desk.license", desk_license)
