# stats.py
#
#

""" the object to resolve. """

## IMPORTS

from meds.utils.time import elapsed, to_time
from meds.utils.parse import parse
from meds.clock import Repeater
from meds.object import Object
from meds.cfg import cfg
from meds.main import main

import logging
import random
import time

## FUNCTIONS

def seconds(nrperjaar):
    if not nrperjaar: return 0
    return int((365 * 24 * 60 * 60) / nrperjaar)

## CMNDS

def mention(*args, **kwargs):
    global display
    p = parse(*args, **kwargs)
    try: name = p.rest.lower()
    except: name = kwargs["name"]
    delta = time.time() - starttime
    if name not in cijfers: return 
    sec = seconds(cijfers.get(name))
    nr = int(delta / sec)
    #txt = "%s" % time.ctime(time.time())
    txt = "%s" % name.upper()
    if name in cijfers: txt += " %d/%d/%s" % (nr, cijfers.get(name, 0), elapsed(seconds(cijfers.get(name))))
    if name in omschrijving: txt += " %s" % omschrijving.get(name)
    txt += ", bijv. uit %s door de %s" % (random.choice(gemeenten.split("\n")), soort.get(name, ""))
    #if name in tags: txt += " %s" % tags.get(name)
    #if name in urls: txt += " - %s" % urls.get(name)
    if args: args[0].reply(txt)
    else: main.announce(txt)

main.register("mention", mention)

## INIT

def init(*args, **kwargs):
    for key, value in display.items():
        if "all" in cfg.main.init or key in cfg.main.init:
            for item in value:
                aantaljaar = cijfers.get(item)
                if aantaljaar:
                    todo = Repeater(seconds(cijfers.get(item)), mention, name=item)
                    main.put(todo.start)

## DEFINES

#startdate = "2012-09-13 00:00:00"
startdate = "2015-01-01 00:00:00"
starttime = to_time(startdate)
source = "http://pypi.python.org/pypi/meds"

## TAGS

tags = Object()
tags.opnames = "#broodjepindakaas"
tags.crisis = "#triade"
tags.suicide = "#wetverplichteggz"
tags.pogingen = "#prettigweekend"
tags.incidenten = "#jammerdan"
tags.acuut = "#geenbedvoorjou"
tags.zorgmijder = "#helaas"
tags.inwoners = "#gebodenvrucht"
tags.crisis = "#gijzultdoden"

## CIJFERS

cijfers = Object()
cijfers.ibs = 7964
cijfers.rm = 14902
cijfers.vwm = 6163
cijfers.mvv = 3966
cijfers.vlm = 4699
cijfers.ev = 65
cijfers.ob = 0
cijfers.zb = 9
cijfers.opnames = 22866
cijfers.crisis = 150000
cijfers.oordeel = 150000
cijfers.suicide = 1854
cijfers.pogingen = 95000
cijfers.incidenten = 51876
cijfers.acuut = 8000
cijfers.zorgmijder = 24000
cijfers.politie = 0.15 * cijfers.crisis
cijfers.hap = 0.40 * cijfers.crisis
cijfers.keten = 0.45 * cijfers.crisis
cijfers.verwijs = cijfers.crisis * 0.85 
cijfers.uitstroom = cijfers.crisis * 0.05
cijfers.opname = cijfers.crisis * 0.10
cijfers.vergiftigingen = 25262
cijfers.neurotoxisch = 0.49 * cijfers.vergiftigingen
cijfers.burenoverlast = 12000
cijfers.huisartsen = 11345
cijfers.speed = 20000
cijfers.cocaine = 50000
cijfers.alcohol = 400000
cijfers.wiet = 500000
cijfers.antipsychotica = 150000
cijfers.antidepresiva = 60000
cijfers.slaapmiddel = 1000000
cijfers.ambulant = 792000
cijfers.verslaving = 13000
cijfers.schizofrenie = 9800
cijfers.depressie = 9600
cijfers.poh = 1300000
cijfers.amitriptyline = 189137
cijfers.paroxetine = 186028
cijfers.citalopram = 154620
cijfers.oxazepam = 133608
cijfers.venlafaxine = 112000
cijfers.mirtazapine = 110742
cijfers.quetiapine = 84414
cijfers.diazepam = 72000
cijfers.sertraline = 68000
cijfers.haloperidol = 59825

dbc = Object()
dbc.middelgebondenstoornissen = 33060
dbc.somatoformestoornissen = 21841
dbc.cognitievestoornissen = 25717
dbc.angststoornissen = 54458
dbc.aanpassingsstoornissen = 43079
dbc.depressievestoornissen = 102361
dbc.eetstoornissen = 8688
dbc.restgroepdiagnose = 16996
dbc.ontbrekendeprimairediagnose = 3030
dbc.andereproblemenredenvoorzorg = 49286
dbc.schizofrenieenanderepsychotischestoornissen = 6798
dbc.bipolairestoornissen = 3569
dbc.posttraumatischestressstoornis = 24716
dbc.persoonlijkheidsstoornissen = 36574
dbc.adhd = 25951
dbc.gedrag = 1176
dbc.kindertijdoverig = 1035
dbc.autismespectrum = 9436

#cijfers.inwoners = 16800000

display = Object()
display.alarm = ["politie", "hap", "keten"]
display.oordeel = ["verwijs", "uitstroom", "opname"]
display.vergiftigingen = ["vergiftigingen", ]
display.neurotoxisch = ["neurotoxisch", ]
display.suicide = ["suicide",]
display.pogingen = ["pogingen",]
display.incidenten = ["incidenten",]
display.acuut = ["acuut",]
#display.zorgmijder = ["zorgmijder", ]
display.opnames = ["ibs", "rm", "vlm", "mvv", "vwm", "ev", "ob", "zb"]
display.meds = ["amitriptyline", "paroxetine", "citalopram",  "oxazepam", "venlafaxine", "mirtazapine", "quetiapine", "diazepam", "sertraline", "haloperidol"]

## OMSCHRIJVING

omschrijving = Object()
omschrijving.ibs = "inbewaringstelling"
omschrijving.rm = "rechterlijke machtiging"
omschrijving.vlm = "voorlopige rechterlijke machtiging"
omschrijving.mvv = "machtiging voortgezet verblijf"
omschrijving.vwm = "voorwaardelijke rechterlijke machtiging"
omschrijving.mev = "machtiging eigen verzoek"
omschrijving.zb = "zelfbinding"
omschrijving.ob = "observatie"
omschrijving.politie = "psychiater bezoekt arrestant in cel"
omschrijving.hap =  "bellen naar de huisartsenpost voor een triade kaart beslissing"
omschrijving.keten = "door ketenpartners aangevoerde patienten o.a. GGZ zelf"
omschrijving.verwijs = 'latere afspraak met een "bekende" zorgverlener'
omschrijving.uitstroom = "opzegging behandelovereenkomst, patient zonder verpleging. zorgzame zorgmijders"
omschrijving.opname = "opname in psychiatrisch ziekenhuis"
omschrijving.poging = "poging tot suicide"
omschrijving.suicide =  "geslaagde zelfmoord poging"
omschrijving.crisis = "crisis beoordeling door crisisdienst van de GGZ"
omschrijving.incidenten = "verwarde man"
omschrijving.acuut = "Spoedeisende Pyschiatrische Hulp"

## URLS

urls = Object()
urls.IBS = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.RM = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.VM = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.MVV = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.VW = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.MEV = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.ZB = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.OB = "http://www.tijdschriftvoorpsychiatrie.nl/assets/articles/57-2015-4-artikel-broer.pdf"
urls.opnames = "http://www.tijdschriftvoorpsychiatrie.nl/issues/434/articles/8318"
urls.crisis = "http://www.rijksoverheid.nl/documenten-en-publicaties/rapporten/2015/02/11/acute-geestelijke-gezondheidszorg-knelpunten-en-verbetervoorstellen-in-de-keten.html"
urls.tuchtrecht = "http://tuchtrecht.overheid.nl/zoeken/resultaat/uitspraak/2014/ECLI_NL_TGZRAMS_2014_94?zaaknummer=2013%2F221&Pagina=1&ItemIndex=1"
urls.suicide = "http://www.cbs.nl/nl-NL/menu/themas/bevolking/publicaties/artikelen/archief/2014/2014-4204-wm.htm"
urls.pogingen = "http://www.veiligezorgiederszorg.nl/speerpunt-suicide/factsheet-trimbos-suicide.pdf"
#urls.incidenten = "https://www.wodc.nl/onderzoeksdatabase/2337-de-effectiviteit-van-de-politiele-taakuitvoering-en-de-taken-en-verantwoordelijkheden-van-andere-partijen.aspx"
urls.zorgmijder = "http://www.gezondheidsraad.nl/sites/default/files/samenvatting_noodgedwongen_0.pdf"
urls.acuut = "http://www.gezondheidsraad.nl/sites/default/files/samenvatting_noodgedwongen_0.pdf"
urls.wvggz = "https://www.dwangindezorg.nl/de-toekomst/wetsvoorstellen/wet-verplichte-geestelijke-gezondheidszorg"
urls.politie = "http://www.rijksoverheid.nl/documenten-en-publicaties/rapporten/2015/02/11/acute-geestelijke-gezondheidszorg-knelpunten-en-verbetervoorstellen-in-de-keten.html"
urls.hap = "http://www.rijksoverheid.nl/documenten-en-publicaties/rapporten/2015/02/11/acute-geestelijke-gezondheidszorg-knelpunten-en-verbetervoorstellen-in-de-keten.html"
urls.keten = "http://www.rijksoverheid.nl/documenten-en-publicaties/rapporten/2015/02/11/acute-geestelijke-gezondheidszorg-knelpunten-en-verbetervoorstellen-in-de-keten.html"
urls.verwijs = "http://www.rijksoverheid.nl/documenten-en-publicaties/rapporten/2015/02/11/acute-geestelijke-gezondheidszorg-knelpunten-en-verbetervoorstellen-in-de-keten.html"
urls.uitstroom = "http://www.rijksoverheid.nl/documenten-en-publicaties/rapporten/2015/02/11/acute-geestelijke-gezondheidszorg-knelpunten-en-verbetervoorstellen-in-de-keten.html" 
urls.opnames = "http://www.rijksoverheid.nl/documenten-en-publicaties/rapporten/2015/02/11/acute-geestelijke-gezondheidszorg-knelpunten-en-verbetervoorstellen-in-de-keten.html"
urls.vergifitigingen = "http://www.umcutrecht.nl/getmedia/f9f152e2-8638-4ffc-a05f-fce72f5f416a/NVIC-Jaaroverzicht-2014.pdf.aspx?ext=.pdf"
urls.neurotoxisch = "http://www.umcutrecht.nl/getmedia/f9f152e2-8638-4ffc-a05f-fce72f5f416a/NVIC-Jaaroverzicht-2014.pdf.aspx?ext=.pdf"
urls.incidenten = "http://www.dsp-groep.nl/userfiles/file/Politie%20en%20verwarde%20personen%20_DSP-groep.pdf"
urls.ambulant = "https://www.zorgprismapubliek.nl/informatie-over/geestelijke-gezondheidszorg/row-3/hoeveel-pati%C3%ABnten-worden-behandeld-zonder-opname/"
urls.verslaving = "https://www.zorgprismapubliek.nl/informatie-over/geestelijke-gezondheidszorg/row-2/voor-welke-aandoening-worden-de-meeste-pati%C3%ABnten-opgenomen/"
urls.poh = "https://www.zorgprismapubliek.nl/informatie-over/geestelijke-gezondheidszorg/row-4/hoe-heeft-de-poh-ggz-zich-in-de-afgelopen-jaren-ontwikkeld/"
urls.meds = "https://www.zorgprismapubliek.nl/informatie-over/geestelijke-gezondheidszorg/row-5/welke-geneesmiddelen-worden-het-meest-voorgeschreven-in-de-ggz/"


def perdag(aantalper100duizend): return  per100duizend * (aantal.inwoners / 100000) / 365

## SOORT

soort = Object()
soort.ibs = "burgemeester"
soort.rm = "rechter"
soort.vlrm = "rechter"
soort.mvv = "rechter"
soort.vwrm = "rechter"
soort.ev = "patient"
soort.ob ="kliniek"
soort.zb = "patient"
soort.politie = "agent"
soort.hap = "huisarts"
soort.keten  = "spv/psychiater"
soort.verwijs = "crisisdienst"
soort.uitstroom = "eigen behandelaar"
soort.suicide = "patient"
soort.crisis = "patient"
soort.pogingen = "patient"
soort.incidenten = "patient"
soort.acuut = "patient"
soort.meds = "patient"
soort.amitriptyline = "patient"
soort.paroxetine = "patient"
soort.citalopram = "patient"
soort.oxazepam = "patient"
soort.venlafaxine = "patient"
soort.mirtazapine = "patient"
soort.quetiapine = "patient"
soort.diazepam = "patient"
soort.sertrali = "patient"
soort.haloperidol = "patient"

## DEFINES

gemeenten = """Amsterdam
Aa en Hunze
Aalburg
Aalsmeer
Aalten
Achtkarspelen
Alblasserdam
Albrandswaard
Alkmaar
Almelo
Almere
Alphen aan den Rijn
Alphen-Chaam
Ameland
Amersfoort
Amstelveen
Amsterdam
Apeldoorn
Appingedam
Arnhem
Assen
Asten
Baarle-Nassau
Baarn
Barendrecht
Barneveld
Bedum
Beek
Beemster
Beesel
Bellingwedde
Bergeijk
Bergen (Limburg)
Bergen (Noord-Holland)
Bergen op Zoom
Berkelland
Bernheze
Best
Beuningen
Beverwijk
Binnenmaas
Bladel
Blaricum
Bloemendaal
Bodegraven-Reeuwijk
Boekel
Bonaire
Borger-Odoorn
Borne
Borsele
Boxmeer
Boxtel
Breda
Brielle
Bronckhorst
Brummen
Brunssum
Bunnik
Bunschoten
Buren
Bussum
Capelle aan den IJssel
Castricum
Coevorden
Cranendonck
Cromstrijen
Cuijk
Culemborg
Dalfsen
Dantumadeel
De Bilt
De Friese Meren
De Marne
De Ronde Venen
De Wolden
Delft
Delfzijl
Den Haag s-Gravenhage
Den Helder
Deurne
Deventer
Diemen
Dinkelland
Doesburg
Doetinchem
Dongen
Dongeradeel
Dordrecht
Drechterland
Drimmelen
Dronten
Druten
Duiven
Echt-Susteren
Edam-Volendam
Ede
Eemnes
Eemsmond
Eersel
Eijsden-Margraten
Eindhoven
Elburg
Emmen
Enkhuizen
Enschede
Epe
Ermelo
Etten-Leur
Ferwerderadeel
Geertruidenberg
Geldermalsen
Geldrop-Mierlo
Gemert-Bakel
Gennep
Giessenlanden
Gilze en Rijen
Goeree-Overflakkee
Goes
Goirle
Gorinchem (Gorcum of Gorkum)
Gouda
Grave
Groesbeek
Groningen
Grootegast
Gulpen-Wittem
Haaksbergen
Haaren
Haarlem
Haarlemmermeer
Halderberge
Hardenberg
Harderwijk
Hardinxveld-Giessendam
Haren
Harlingen
Hattem
Heemskerk
Heemstede
Heerde
Heerenveen
Heerhugowaard
Heerlen
Heeze-Leende
Heiloo
Hellendoorn
Hellevoetsluis
Helmond
Hendrik-Ido-Ambacht
Hengelo (Overijssel)
s-Hertogenbosch (Den Bosch)
Het Bildt
Heumen
Heusden
Hillegom
Hilvarenbeek
Hilversum
Hof van Twente
Hollands Kroon
Hoogeveen
Hoogezand-Sappemeer
Hoorn
Horst aan de Maas
Houten
Huizen
Hulst
IJsselstein
Kaag en Braassem
Kampen
Kapelle
Katwijk
Kerkrade
Koggenland
Kollumerland en Nieuwkruisland
Korendijk
Krimpen aan den IJssel
Krimpenerwaard
Laarbeek
Landerd
Landgraaf
Landsmeer
Langedijk
Lansingerland
Laren
Leek
Leerdam
Leeuwarden
Leeuwarderadeel
Leiden
Leiderdorp
Leidschendam-Voorburg
Lelystad
Leudal
Leusden
Lingewaal
Lingewaard
Lisse
Littenseradeel
Lochem
Loon op Zand
Lopik
Loppersum
Losser
Maasdriel
Maasgouw
Maassluis
Maastricht
Marum
Medemblik
Meerssen
Menaldumadeel
Menterwolde
Meppel
Middelburg
Midden-Delfland
Midden-Drenthe
Mill en Sint Hubert
Moerdijk
Molenwaard
Montferland
Montfoort
Mook en Middelaar
Muiden
Naarden
Neder-Betuwe
Nederweert
Neerijnen
Nieuwegein
Nieuwkoop
Nijkerk
Nijmegen
Nissewaard
Noord-Beveland
Noordenveld
Noordoostpolder
Noordwijk
Noordwijkerhout
Nuenen, Gerwen en Nedercoreten
Nunspeet
Nuth
Oegstgeest
Oirschot
Oisterwijk
Oldambt
Oldebroek
Oldenzaal
Olst-Wijhe
Ommen
Onderbanken
Oost Gelre
Oosterhout
Ooststellingwerf
Oostzaan
Opmeer
Opsterland
Oss
Oud-Beijerland
Oude IJsselstreek
Ouder-Amstel
Oudewater
Overbetuwe
Papendrecht
Peel en Maas
Pekela
Pijnacker-Nootdorp
Purmerend
Putten
Raalte
Reimerswaal
Renkum
Renswoude
Reusel-De Mierden
Rheden
Rhenen
Ridderkerk
Rijnwaarden
Rijssen-Holten
Rijswijk
Roerdalen
Roermond
Roosendaal
Rotterdam
Rozendaal
Rucphen
Saba
Schagen
Scherpenzeel
Schiedam
Schiermonnikoog
Schijndel
Schinnen
Schouwen-Duiveland
Simpelveld
Sint Anthonis
Sint Eustatius
Sint-Michielsgestel
Sint-Oedenrode
Sittard-Geleen
Sliedrecht
Slochteren
Sluis
Smallingerland
Soest
Someren
Son en Breugel
Stadskanaal
Staphorst
Stede Broec
Steenbergen
Steenwijkerland
Stein
Stichtse Vecht
Strijen
Ten Boer
Terneuzen
Terschelling
Texel
Teylingen
Tholen
Tiel
Tietjerksteradeel
Tilburg
Tubbergen
Twenterand
Tynaarlo
Uden
Uitgeest
Uithoorn
Urk
Utrecht
Utrechtse Heuvelrug
Vaals
Valkenburg aan de Geul
Valkenswaard
Veendam
Veenendaal
Veere
Veghel
Veldhoven
Velsen
Venlo
Venray
Vianen
Vlaardingen
Vlagtwedde
Vlieland
Vlissingen
Voerendaal
Voorschoten
Voorst
Vught
Waalre
Waalwijk
Waddinxveen
Wageningen
Wassenaar
Waterland
Weert
Weesp
Werkendam
West Maas en Waal
Westerveld
Westervoort
Westland
Weststellingwerf
Westvoorne
Wierden
Wijchen
Wijdemeren
Wijk bij Duurstede
Winsum
Winterswijk
Woensdrecht
Woerden
Wormerland
Woudenberg
Woudrichem
Zaanstad
Zaltbommel
Zandvoort
Zederik
Zeevang
Zeewolde
Zeist
Zevenaar
Zoetermeer
Zoeterwoude
Zuidhorn
Zuidplas
Zundert
Zutphen
Zwartewaterland
Zwijndrecht
Zwolle"""
