# meds/services/system.py
#
#

""" MEDS system services. """

## IMPORTS

from meds.main import main, plugins
from meds.clock import Repeater

## CMNDS

def syncer(*args, **kwargs):
    for name, plug in plugins.items():
        syncer = getattr(plug, "sync", None)
        if syncer: syncer()
    if args: main.announce("synced")
    
main.register("sync", syncer) 

def init(*args, **kwargs):
    todo = Repeater(60, syncer)
    main.put(todo.start)
