# meds/plugins/write.py
#
#

""" storage. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from meds.utils.time import short_date
from meds.main import main
from meds.errors import error
from meds.object import Object

import urllib.parse
import logging
import mailbox
import html
import os

## CMNDS

def write_mbox(event):
    fn = os.path.expanduser(event.parsed.args[0])
    nr = 0
    try: object = mailbox.Maildir(fn, create=False)
    except: 
        try: object = mailbox.mbox(fn, create=False)
        except: event.reply("need a mbox or maildir.") ; return
    for m in object:
        o = Object()
        o.update(m.items())
        try: sdate = os.sep.join(short_date(o.Date).split())
        except AttributeError: sdate = None
        o.text = bytes()
        for load in m.walk():
            if load.get_content_type() == 'text/plain': o.text += load.get_payload(decode=True)
        o.text = str(o.text, "latin-1")
        o.prefix = "email"
        if sdate: o.save(sdate)
        else: o.save()
        nr += 1
    logging.warn("# Write/mbox %s" % nr)
    event.ok(nr)
    return nr

main.register("write.mbox", write_mbox)

## CMNDS

def write_log(event):
    o = Object(event)
    o.prefix = "log"
    o.log = event.parsed.rest
    path = o.save()
    logging.warn("# Write/log 1")
    event.ok(1)

main.register("write.log", write_log)

def write_todo(event):
    o = Object(event)
    o.prefix = "todo"
    o.todo = event.parsed.rest
    path = o.save()
    logging.warn("# Write/todo 1")
    event.ok(1)

main.register("write.todo", write_todo)

def write_status(event):
    o = Object(event)
    o.prefix = "status"
    o.status = event.parsed.rest
    path = o.save()
    logging.warn("# Write/status 1")
    event.ok(1)

main.register("write.status", write_status)

def write_user(event):
    if not main.allowed(event.origin): event.reply("ENOTALLOWED %s" % event.origin) ; return
    if "@" not in event.parsed.rest: event.reply("ENOTAUSERHOST %s" % event.parsed.rest) ; return
    o = Object(event)
    o.prefix = "user"
    o.user = event.parsed.rest
    path = o.save()
    logging.warn("# Write/user 1")
    event.ok(1)

main.register("write.user", write_user)

def write_rss(event):
    o = Object(event)
    o.prefix = "rss"
    o.rss = event.parsed.rest  
    o.service = "rss"
    path = o.save()  
    logging.warn("# Write/rss 1")
    event.ok(1)

main.register("write.rss", write_rss)   

def write_symptom(event):
    o = Object(event)
    o.prefix = "symptom"
    o.symptom = event.parsed.rest 
    if "karma" in event.parsed: o.karma = event.parsed.karma 
    path = o.save()  
    logging.warn("# Write/rss 1")
    event.ok(1)

main.register("write.symptom", write_symptom)

