# file.py
#
#

""" utils package. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORT

import logging
import glob
import os
from stat import *

## DEFINES

dirmask = 0o700
filemask = 0o600

## FILES

def list_files(*args, **kwargs):
    path = args[0]
    if len(args) > 1: prefix = args[1]
    else: prefix = ""
    res = []
    nr = 0
    if "nr" in kwargs: nr += kwargs["nr"]
    if not path.endswith(os.sep): path += os.sep
    if prefix and os.path.isdir(path + prefix): path += prefix
    if "*" not in path: path += "*"
    for fnn in glob.glob(path):
        if os.path.isdir(fnn):
            kwargs["nr"] = nr
            res.extend(list_files(fnn, **kwargs)) ; continue
        if "time" in kwargs and kwargs["time"] not in fnn: continue
        if fnn: res.append(fnn)
        nr += 1
    else: logging.debug("# Utils/files %s" % str(nr))
    return res 

def touch(fname):
    try: fd = os.open(fname, os.O_RDONLY | os.O_CREAT) ; os.close(fd)
    except: error()
    logging.warn("# Utils/touch %s" % fname)

def check_permissions(ddir, dirmask=dirmask, filemask=filemask):
    uid = os.getuid()
    gid = os.getgid()
    try: stat = os.stat(ddir)
    except OSError: cdir(ddir) ; stat = os.stat(ddir)
    if stat.st_uid != uid: os.chown(ddir, uid, gid)
    if os.path.isfile(ddir): mask = filemask
    else: mask = dirmask
    m = oct(S_IMODE(stat.st_mode))
    if m != oct(mask):
        os.chmod(ddir, mask)
        logging.warn("# Utils/permissions %s" % ddir)

def cdir(path):
    res = "" 
    for p in path.split(os.sep):
       res += "%s%s" % (p, os.sep)
       padje = os.path.abspath(os.path.normpath(res))
       if os.path.isdir(padje): continue
       try: os.mkdir(padje) ; logging.warn("# Utils/cdir %s" % cdir)
       except FileExistsError: pass
       except OSError: error()
    return True

## HIGHEST

def high(target, file_name):
    """ determine new file extension. """
    highest = 0
    for i in os.listdir(target):
        if file_name in i:
            try: seqnr = i.split('.')[-1]
            except IndexError: continue  
            try:
                if int(seqnr) > highest: highest = int(seqnr)
            except ValueError: pass
    logging.warn("# Utils/high %s" % target)
    return highest

def highest(target, filename):
    """ determine new file extension. """
    nr = high(target, filename)
    logging.warn("# Utils/highest %s" % target)
    return "%s.%s" % (filename, nr+1)
